//+------------------------------------------------------------------+
//|                                                        TSI_s.mq4 |
//|                                                 Kamil Gazizullin |
//|                                             forexman77@yandex.ru |
//+------------------------------------------------------------------+
#property copyright "QuantF"
#property link      "quantumtrade7@gmail.com"
#property version   "1.00"
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  LimeGreen
#property indicator_color2  Red  
#property indicator_width1  2
#property indicator_width2  2
//--- input parameters
extern int       Period_MA_r=1;
extern int       r2 =20;
extern int       r3 =5;
extern int       r4 =3;
extern int       countdown=7;
//--- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double ExtMapBuffer5[];
double ExtMapBuffer6[];
double ExtMapBuffer7[];
double ExtMapBuffer8[];
double ExtMapBuffer9[];
double ExtMapBuffer10[];
double hup[];
double hdn[];

int tikket;
datetime time;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(12);
   SetIndexBuffer(0,hup); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,hdn); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,ExtMapBuffer1);
   SetIndexBuffer(3,ExtMapBuffer2);
   SetIndexBuffer(4,ExtMapBuffer3);
   SetIndexBuffer(5,ExtMapBuffer4);
   SetIndexBuffer(6,ExtMapBuffer5);
   SetIndexBuffer(7,ExtMapBuffer6);
   SetIndexBuffer(8,ExtMapBuffer7);
   SetIndexBuffer(9,ExtMapBuffer8);
   SetIndexBuffer(10,ExtMapBuffer9); 
   SetIndexBuffer(11,ExtMapBuffer10); 
   SetIndexEmptyValue(0,0);
   SetIndexEmptyValue(1,0);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int i,limit1 = MathMin(Bars-counted_bars,Bars-1);
   
   for(i=limit1;i>=0;i--) ExtMapBuffer3[i]=Close[i]-Close[i+Period_MA_r];
   for(i=limit1;i>=0;i--) ExtMapBuffer4[i]=MathAbs(Close[i]-Close[i+Period_MA_r]);
   for(i=limit1;i>=0;i--) ExtMapBuffer5[i]=iMAOnArray(ExtMapBuffer3,0,r2,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer6[i]=iMAOnArray(ExtMapBuffer4,0,r2,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer7[i]=iMAOnArray(ExtMapBuffer5,0,r3,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer8[i]=iMAOnArray(ExtMapBuffer6,0,r3,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer9[i]=iMAOnArray(ExtMapBuffer7,0,r4,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--) ExtMapBuffer10[i]=iMAOnArray(ExtMapBuffer8,0,r4,0, MODE_EMA,i);
   for(i=limit1;i>=0;i--){ExtMapBuffer1[i]=100*ExtMapBuffer9[i]/ExtMapBuffer10[i];} 
   for(i=limit1;i>=0;i--)
   {
      hup[i] = hup[i+1];
      hdn[i] = hdn[i+1];
      if(ExtMapBuffer1[i]>0) { hup[i] += 1; hdn[i] = 0; }
      if(ExtMapBuffer1[i]<0) { hdn[i] -= 1; hup[i] = 0; }
     }
   return(0);
  }
//+------------------------------------------------------------------+
